#!/usr/bin/php4
<?

/* From update.php */

include_once "database/updates.inc";

function update_data($start) {
  global $sql_updates;
  $sql_updates = array_slice($sql_updates, ($start-- ? $start : 0));
  foreach ($sql_updates as $date => $func) {
    print "<strong>$date</strong><br />\n<pre>\n";
    $ret = $func();
    foreach ($ret as $return) {
      print $return[1];
      print $return[2];
    }
    variable_set("update_start", $date);
    print "</pre>\n";
  }
}

/* End update.php */

/**********************************************************************/

// Not used
// Why does update.php output these lines?
function update_to_4_3() {
  $ret = array();
  $ret[] = update_sql("CREATE TABLE sessions (uid int(10) unsigned NOT NULL, sid varchar(32) NOT NULL default '', hostname varchar(128) NOT NULL default '', timestamp int(11) NOT NULL default '0', session text, KEY uid (uid), KEY sid (sid(4)), KEY timestamp (timestamp));");
  return $ret;
}
// Not used
// Why does update.php output these lines?
function update_to_4_4() {
  $ret = array();
    if ($GLOBALS["db_type"] == "mysql") {
      $ret[] = update_sql("ALTER TABLE system ADD throttle tinyint(1) NOT NULL DEFAULT '0';");
      $ret[] = update_sql("ALTER TABLE system ADD bootstrap int(2);");
    }
    else {
      $ret[] = update_sql("ALTER TABLE system ADD throttle smallint;");
      $ret[] = update_sql("ALTER TABLE system ALTER COLUMN throttle SET DEFAULT '0';");
      $ret[] = update_sql("UPDATE system SET throttle = 0;");
      $ret[] = update_sql("ALTER TABLE system ALTER COLUMN throttle SET NOT NULL;");
      $ret[] = update_sql("ALTER TABLE system ADD bootstrap integer;");
    }
  return $ret;
}

function update_to_4_5() {
  $ret = array();
  $ret[] = update_sql("CREATE TABLE IF NOT EXISTS users_roles (uid int(10) unsigned NOT NULL default '0', rid int(10) unsigned NOT NULL default '0', PRIMARY KEY (uid, rid));");
  
  $ret[] = update_sql("CREATE TABLE IF NOT EXISTS locales_meta ( locale varchar(12) NOT NULL default '', name varchar(64) NOT NULL default '', enabled int(2) NOT NULL default '0', isdefault int(2) NOT NULL default '0', plurals int(1) NOT NULL default '0', formula varchar(128) NOT NULL default '', PRIMARY KEY  (locale) );");
  return $ret;
}

/**********************************************************************
 **********************************************************************
 Stuff from bootstrap.inc */

function conf_init() {
  $uri = $_SERVER['PHP_SELF'];

  $file = strtolower(strtr($_SERVER['HTTP_HOST'] . substr($uri, 0, strrpos($uri, '/')), '/:', '..'));

  while (strlen($file) > 4) {
    if (file_exists('includes/'. $file .'.php')) {
      return $file;
    }
    else {
      $file = substr($file, strpos($file, '.') + 1);
    }
  }

  return 'conf';
}

function variable_init($conf = array()) {
  // NOTE: caching the variables improves performance with 20% when serving cached pages.
  if ($cached = cache_get('variables')) {
    $variables = unserialize($cached->data);
  }
  else {
    $result = db_query('SELECT * FROM {variable}');
    while ($variable = db_fetch_object($result)) {
      $variables[$variable->name] = unserialize($variable->value);
    }
    cache_set('variables', serialize($variables));
  }

  foreach ($conf as $name => $value) {
    $variables[$name] = $value;
  }

  return $variables;
}

function variable_get($name, $default) {
  global $conf;

  return isset($conf[$name]) ? $conf[$name] : $default;
}

function variable_set($name, $value) {
  global $conf;

  db_query("DELETE FROM {variable} WHERE name = '%s'", $name);
  db_query("INSERT INTO {variable} (name, value) VALUES ('%s', '%s')", $name, serialize($value));
  cache_clear_all('variables');

  $conf[$name] = $value;
}

function variable_del($name) {
  global $conf;

  db_query("DELETE FROM {variable} WHERE name = '%s'", $name);
  cache_clear_all('variables');

  unset($conf[$name]);
}

function cache_get($key) {
  $cache = db_fetch_object(db_query("SELECT data, created, headers FROM {cache} WHERE cid = '%s'", $key));
  if (isset($cache->data)) {
    $cache->data = db_decode_blob($cache->data);
    return $cache;
  }
  return 0;
}

function cache_set($cid, $data, $expire = CACHE_PERMANENT, $headers = NULL) {
  $data = db_encode_blob($data);

  db_query("UPDATE {cache} SET data = '%s', created = %d, expire = %d, headers = '%s' WHERE cid = '%s'", $data, time(), $expire, $headers, $cid);
  if (!db_affected_rows()) {
    @db_query("INSERT INTO {cache} (cid, data, created, expire, headers) VALUES ('%s', '%s', %d, %d, '%s')", $cid, $data, time(), $expire, $headers);
  }
}

function cache_clear_all($cid = NULL, $wildcard = false) {
  if (empty($cid)) {
    db_query("DELETE FROM {cache} WHERE expire != %d AND expire < %d", CACHE_PERMANENT, time());
  }
  else {
    if ($wildcard) {
      db_query("DELETE FROM {cache} WHERE cid LIKE '%%%s%%'", $cid);
    }
    else {
      db_query("DELETE FROM {cache} WHERE cid = '%s'", $cid);
    }
  }
}

function check_query($text) {
  return addslashes($text);
}

function drupal_unpack($obj, $field = 'data') {
  if ($obj->$field && $data = unserialize($obj->$field)) {
    foreach ($data as $key => $value) {
      if (!isset($obj->$key)) {
        $obj->$key = $value;
      }
    }
  }
  return $obj;
}

/* bootstrap.inc end
 **********************************************************************
 **********************************************************************/

unset($conf);
$config = conf_init();

include_once "includes/$config.php";
include_once 'includes/database.inc';

/* Fix for buggy MySQL DB entry generated by 4.4.x packages. */
cache_clear_all('variables');
db_query("UPDATE `variable` SET `value` = 's:10:\"2004-02-21\";' WHERE `name` = 'update_start' AND `value` = 's:10:\"2004-02-21;\"'");

unset($conf);
$conf = variable_init(isset($conf) ? $conf : array());

$start = variable_get("update_start", "undef");

/* Normally, update.php tells the user to create the tables by hand. 
   Can't do this. */
if ($start == "2004-02-21") {
  update_to_4_5();
}

include_once 'modules/user.module';

/* Select update functions */
foreach ($sql_updates as $date => $sql) {
  $dates[$i++] = $date;
  if ($date == $start) {
    $selected = $i;
  }
}

/* Perform updates */
update_data(++$selected);

?>
